# -*- coding: iso-8859-1 -*-
"""
Das hier ist das quivalent von schwob.py, nur zur Verwendung mit
mod_python.	Wer nicht wei, was das ist, kann es ignorieren.
"""

from mod_python import apache, util
import os, sys, re, cgi, string, urllib, UserString
import time, traceback

import translator
import index
import common
import schwob

class StringWithValue(UserString.UserString):
	"""Kompatibilittsklasse, damit die mod_python-Werte wie Werte aus
	cgi.FieldStorage aussehen.
	"""
	def __init__(self, val):
		UserString.UserString.__init__(self, val)
		self.value = val
	

class ValueWithValue:
	def __init__(self, val):
		self.value = val


class MyFieldStorage(util.FieldStorage):
	"""Kompatibilittsklasse, damit das FieldStorage von mod_python wie
	das von cgi aussieht.
	"""
	def __getitem__(self, key):
		val = util.FieldStorage.__getitem__(self, key)
		return ValueWithValue(val)

class Request:
	"""Eine Klasse, die die Schnittstelle zum Webserver abstrahiert --
	wird hier mit dem Request von mod_python konstruiert.
	"""
	def __init__(self, mPReq):
		self._modpyServer = mPReq.server
		self.requestMethod = mPReq.method
		self.unparsedURI = mPReq.unparsed_uri
		self.path_info = re.sub(r"\?.*", "", self.unparsedURI)
		self.httpHeaders = mPReq.headers_in
		self.form = MyFieldStorage(mPReq)

	def log(self, s):
		apache.log_error(s, apache.APLOG_ERR, self._modpyServer)


def printError(msg, req):
	req.status = 500
	req.content_type = "text/plain"
	req.send_http_header()
	req.write("Ein Fehler ist aufgetreten:\n\n"
		"%s\n"%msg)

def output(doc, req):
	req.status = 200
	req.content_type = doc.content_type
	stuff = doc.getData()+doc.getFooter()
	req.headers_out["Content-Length"] = str(len(stuff))
	req.send_http_header()
	req.write(stuff)


def handler(req):
	try:
		request = Request(req)
		try:
			answer = schwob.dispatch(request)
			output(answer, req)
		except common.Error, msg:
			printError(msg, req)
		except common.Redirect, msg:
			req.status = 301
			req.content_type = "text/html"
			req.headers_out["Location"] = str(msg)
			req.send_http_header()
			req.write('<head><title>Moved Permanently</title></head>'
				'<body><p>Du solltest das ja eigentlich nicht sehen, aber'
				'weils nun schon mal passiert ist: Klicke'
				'<a href="%s">hier</a>.</p></body>'%str(msg))
	except:
		import StringIO
		strFile = StringIO.StringIO()
		traceback.print_exc(None,strFile)
		req.status = 500
		req.content_type = "text/html"
		req.send_http_header()
		req.write("<head><title>Schwerer Fehler</title><head>\n"
		 	"<body>\n"
			'<p>Bser Fehler.	Bitte das Folgende an <a href='
			'"mailto:%(maintainer)s">den Maintainer</a> dieser Seite'
			' schicken:</p><pre>%(traceback)s</pre>\n</body>'%{
			"maintainer": common.maintainerAddress,
			"traceback": re.sub("\n","<BR>",
				re.sub(">","&gt;",
				re.sub("<","&lt;",
				strFile.getvalue())))}
		)
	return apache.OK
